//Old working code, kept for reference
//Mixed reality Mirohot with Kinect by Shiou-Min Shen
//OpenCVGLKinect.cpp contains the main function of the program, user interface,
//OpenCV image processing, OpenGL virtual game and, and robot controls
//Program builds on existing Experimental Robotics Lab Mirohot program on image processing and robot control

//declare libaray
#include <opencv/highgui.h>
#include <iostream>
#include <opencv/cv.h>

#include <windows.h>
#include <gl/Gl.h>
#include <gl/Glu.h>
//#include <gl/glut.h>
#include <gl/freeglut.h>

#include <stdio.h>
#include <string>
#include <sstream> 
#include <cmath> 
#include <math.h>
#include <fstream>  
// 0xCB=six size/3sizes
// 0xBB=five size/more than 10sizes
// 0xAB=four size/7-9sizes
//For FTDI
#include <windows.h>
#include "ftdi.h"
#include "utilitiesGL.h"
#include "kinectTODO.h"
//using namespace cv;
//using namespace std;
//#define Robot1 0xAB;
#define Robot1 0xAA;
#define Robot2 0xBB;
#define Robot3 0xCB;
#define PI 3.14159265
#define RATIO 2.005 // mm/pixel

ftdi usb;	//initialize an instance of class ftdi

#pragma pack(push)
#pragma pack(1)
struct tPack
{
	unsigned char start;
	unsigned char ID;
	//short cmd;
	unsigned char commd;
	short v;
	short w;
	unsigned char checksum;
	unsigned char end;
};
#pragma pack(pop)


//global declaraion of variables
cv::Mat src;
cv::Mat drawing;
int threshCanny = 100;
int thresholdValue = 235;
int thresholdMax = 255;
double areaThreshold = 150;
double areaThresholdMax = 500;
double orientation,orientation2,Xpuck,Ypuck = 0;
double orientation3,orientation4,torientation,torientation2,orientation5,orientation6=0;
double trobotDistance,robotDistance1,robotDistance2,robotDistance3=0;
double linSpeed=150;
double angVel,linVel=0;
double txPos,tyPos,xPos1,yPos1,xPos2,yPos2,xPos3,yPos3=0;
//color
cv::Scalar color1 = cv::Scalar( 200, 180, 230 );
cv::Scalar color2 = cv::Scalar( 100, 8, 230 );
cv::Scalar color3 = cv::Scalar( 210, 80, 130 );
cv::Scalar color4 = cv::Scalar( 10, 180, 130 );
cv::Scalar color6 = cv::Scalar( 20, 50, 30 );
cv::Scalar color5 = cv::Scalar( 120, 250, 30 );
cv::Scalar color7 = cv::Scalar( 150, 180, 180 );
unsigned char shoot = 0x01;

/////////////////////////////////////////////////
#define botNONE 99
double m_scale = 1.0;

INuiSensor* sensor;
INuiInteractionStream* interactionStream;
CIneractionClient m_nuiIClient;

BYTE depthBuffer[640*480*4];

//cv::Mat cvImageColor(640, 480, CV_8UC3);;
//cv::Mat cvImageDepth(480, 640, CV_8UC4);
cv::Mat cvImageDepth(cv::Size(640, 480), CV_8UC4, depthBuffer, cv::Mat::AUTO_STEP);
cv::Mat m_scale_img;

//CvPoint2D32f m_Points[NUI_SKELETON_POSITION_COUNT];

CvPoint SkeletonPts[NUI_SKELETON_POSITION_COUNT];

HANDLE colorEvent, 
colorHandle,
depthEvent,
depthHandle,
skeletonEvent,
interactionEvent;

//NUI_HANDPOINTER_INFO hands[HANDSTOTAL];
//HandInfo hands[HANDSTOTAL];

int scores[2];
int scoretimer = 0;

struct bot
{
	double X,Y;
	double destX,destY;
	double velocity;
	//vec3 pos;
	//vec3 dest;
	double angle;
	double angVel;
	//float color[3];
	cv::Scalar color;
	bool highlight;
	//bot();
	//void drawbotGL(float botsize, GLUquadric* qobj);
	void init();
};

struct botteam
{
	bot botset[2];
	void init();
};

void bot::init()
{
	X = 0.0;
	Y = 0.0;
	destX = 0.0;
	destY = 0.0;
	angle = 0.0;
	velocity = 0.0;
	angVel = 0.0;
	color = cv::Scalar( 0, 0, 0 );
	highlight = false;
}

void botteam::init()
{
	botset[0].init();
	botset[1].init();
}

void HandInfo::init()
{
	X = 0.0;
	Y = 0.0;
	drawX = 0.0;
	drawY = 0.0;
	doGrip = false;
	didGrip = false;
	isValid = false;
	SkeletonTrackingId = 0x0000;

	selectbot = botNONE;
}

void UserInfo::init()
{
	hands[0].init();
	hands[1].init();
}

struct puck
{
	float X;
	float Y;
	//vec3 vel;
	//vec3 accel;
	float radius;
	float angle;
	float speed;
	void init();
};

void puck::init()
{
	X= 0.0f;
	Y= 0.0f;

	radius = 5.0f;
	angle = 0.0f;	
	speed = 0.0;
};

void initGame();

UserInfo iPlayers[2];
//bot botset[3];

botteam team[2];

puck puck1;


//////////////////////////////////////////////////
///OPENGL

//void glutMainLoopEvent ( void );

int window1; //window ID

GLfloat light_diffuse_color[] = {1.0, 1.0, 1.0, 1.0};
GLfloat light_ambient_color[] = {0.5, 0.5, 0.5, 1.0};
GLfloat light_specular_color[] = {0.0, 0.5, 0.0, 1.0};
GLfloat light_diffuse_position[] = {1.0, 1.0, 0.0, 0.0};
GLfloat light_ambient_position[] = {0.0, 0.0, 0.0, 0.0};
GLfloat light_specular_position[] = {1.0, 1.0, 0.0, 0.0};

bool gIsRotatingCamera = false;

float tempX = 0.0;
float tempY = 0.0;
float tempA;
float screenH = 480.0;
float screenW = 640.0;
 
float botsize = 50.0;
const float botspeed = 4.0f;
//const float botangspeed = 10.0f;
//const int botcount = 2;
const float Collide_force = 17.0f;
const float Friction_coeff = 0.6f;
const float Kick_force = 30.0f;

double linearSpeedV(double &x1, double &y1, double &x2, double &y2,double &thetaSource, double &thetaDest);
bool angleCorrectV(double &thetaSource, double &thetaDest);
double angleSpeedV(double &thetaSource, double &thetaDest);
void robotSpeedV(bot &robot1, double robotDistance);

void initGame()
{
	/*for (int n=0; n<2; n++) {
		botlocation[n][3] = 0;
		botorientation[n] = 0;
	}*/
	
	for (int i = 0; i < 2; i++)
	{	
	for (int j = 0; j < 2; j++)
	{
		team[i].botset[j].init();

		team[i].botset[j].X = (i+0.5)*screenW/2.0;
		team[i].botset[j].Y = (j+0.5)*screenH/2.0;

		team[i].botset[j].destX = (i+0.5)*screenW/2.0;
		team[i].botset[j].destY = (j+0.5)*screenH/2.0;

		/*team[i].botset[j].X = screenW*1.5/2.0;
		team[i].botset[j].Y = screenH*1.5/2.0;

		team[i].botset[j].destX = screenW*1.5/2.0;
		team[i].botset[j].destY = screenH*1.5/2.0;*/

		team[i].botset[j].color[0] = float(i)*1.0f;
		team[i].botset[j].color[1] = 0.0f;
		team[i].botset[j].color[2] = 0.5f;

		team[i].botset[j].angle = float(i)*180.0f;
	}
	}

	puck1.init();

	puck1.X= screenW/2.0;
	puck1.Y= screenH/2.0;


	for (int iuse = 0; iuse<2; iuse++)
	{
	for (int ihand = 0; ihand<2; ihand++)
	{
		iPlayers[iuse].hands[ihand].selectbot = botNONE; 
	}
	}
}

void glutIdle()
{
	//void glutTimerFunc(unsigned int msecs, void (*func)(int value), value);

    glutPostRedisplay();
}



void drawbotGL(bot &bot1, float &botsize, GLUquadric* qobj)
{
	//draw destination line
	glLineWidth(3);
	glColor3f(0.0f,0.0f,0.0f);
	glBegin(GL_LINE_STRIP);
	glVertex3f( bot1.X, bot1.Y, 0.0f);    
	glVertex3f( bot1.destX, bot1.destY, 0.0f);    	
	glEnd();
	

	glLineWidth(1);
	glPushMatrix ();

	glTranslatef(bot1.X, bot1.Y, botsize/2);

	glRotatef(bot1.angle, 0.0f, 0.0f, 1.0f);

	//glColor4f(color[0], color[1], color[2], 0.1f);

	glColor3f(bot1.color[0], bot1.color[1], bot1.color[2]);

	drawcube(botsize);

	///////draw wheels	

	gluQuadricNormals(qobj, GLU_FLAT);

	if (bot1.highlight)
		glColor3f(1, 1, 1);
	else
		glColor3f(0, 0, 0);

	glPushMatrix ();
	glTranslatef(0, botsize/2, -botsize/4);
	glRotatef(-90, 1.0f, 0.0f, 0.0f);
	gluCylinder(qobj, 15.0, 15.0, 10, 9, 9);
	glPopMatrix ();

	glPushMatrix ();
	glTranslatef(0, -botsize/2, -botsize/4);
	glRotatef(90, 1.0f, 0.0f, 0.0f);
	gluCylinder(qobj, 15.0, 15.0, 10, 9, 9);
	glPopMatrix ();
	
	///////draw tip
	glTranslatef(botsize/2, 0, botsize/2);

	glScalef(1.0f,  0.5f, 1.0f);

	//glColor3f(0, 0, 0);

	drawcube(botsize/4);

	glPopMatrix ();
}

void doInit() {
    glViewport(0, 0, screenW, screenH);
	//void glViewport(GLint  x,  GLint  y,  GLsizei  width,  GLsizei  height);

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	//glOrtho(-32, 32, -24, 24, 50, -50); 
	//glOrtho(-screenW/2, screenW/2, screenH/2, -screenH/2, 1000.0, -1000.0);
	glOrtho(0, screenW, screenH, 0, 1000.0, -1000.0); 
	//void glOrtho(GLdouble left,GLdouble right,
			//GLdouble bottom,GLdouble top,GLdouble near,GLdouble far)

	glMatrixMode( GL_MODELVIEW );
}

void reshapeGlut(int width, int height) 
{
    glViewport(0,0,width,height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0, GLdouble (width), GLdouble (height), 0, 1000.0, -1000.0);
    glMatrixMode(GL_MODELVIEW);
    //glLoadIdentity();
}

void drawtextGL (std::string mytext, float x, float y, void * font)
{
	glColor3f(1.0, 1.0, 1.0);

	glRasterPos2i(x, y);

	//std::string s = "test line 1";
	//void * font = GLUT_BITMAP_HELVETICA_18; //GLUT_BITMAP_9_BY_15;
	for (std::string::iterator i = mytext.begin(); i != mytext.end(); ++i)
	{
		char c = *i;
		glutBitmapCharacter(font, c);
	}
}

void drawSceneWIDE() 
{
	GLUquadric* qobj;
///////////////
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glClearColor (0.2, 0.2, 0.2, 0.0);	
	
	glLoadIdentity();
	//gluLookAt(10, 3, 10, 0, 0, 0, 0, 1, 0); 

	//moveCamera();
	
	glEnable(GL_COLOR_MATERIAL);

	glEnable (GL_BLEND);

	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//draw top objects the last to prevent wrong overlap
	glColor3f(0.8f, 0.8f, 0.8f);

	glBegin(GL_POLYGON);
	glVertex3f( screenW * 0.96, screenH * 0.96, -2.0f);    // base
	glVertex3f( screenW * 0.04, screenH * 0.96, -2.0f);
	glVertex3f( screenW * 0.04, screenH * 0.04, -2.0f);
	glVertex3f( screenW * 0.96, screenH * 0.04, -2.0f);
	glEnd();

	glColor3f(1.0f,0,0); 
	glBegin(GL_POLYGON);	//goal
	glVertex3f( 0,              screenH/2 - botsize, 0.0f);
	glVertex3f( screenW * 0.04, screenH/2 - botsize, 0.0f);
	glVertex3f( screenW * 0.04, screenH/2 + botsize, 0.0f);
	glVertex3f( 0,              screenH/2 + botsize, 0.0f);
	glEnd();

	glBegin(GL_POLYGON);	//goal
	glVertex3f( screenW,        screenH/2 - botsize, 0.0f);
	glVertex3f( screenW * 0.96, screenH/2 - botsize, 0.0f);
	glVertex3f( screenW * 0.96, screenH/2 + botsize, 0.0f);
	glVertex3f( screenW,        screenH/2 + botsize, 0.0f);
	glEnd();
	

	glColor3f(1.0f,0.5f,0.5f); //position reset button

	glBegin(GL_QUADS);
	glVertex3f(screenW-botsize/1.5, 0.0f, 0.0f);    
	glVertex3f(screenW,             0.0f, 0.0f);
	glVertex3f(screenW,             botsize/1.5, 0.0f);  
	glVertex3f(screenW-botsize/1.5, botsize/1.5, 0.0f);  
	glEnd();

	glColor3f(0.5f,0.5f,1.0f); //score reset button

	glBegin(GL_QUADS);
	glVertex3f(screenW-botsize/1.5, screenW, 0.0f);    
	glVertex3f(screenW,             screenW, 0.0f);
	glVertex3f(screenW,             screenH-botsize/1.5, 0.0f);  
	glVertex3f(screenW-botsize/1.5, screenH-botsize/1.5, 0.0f);  
	glEnd();

	drawtextGL("Reset Game", screenW - 135, botsize/3, GLUT_BITMAP_HELVETICA_18);
	drawtextGL("Reset Score", screenW - 135, screenH-3, GLUT_BITMAP_HELVETICA_18);

	drawtextGL("Blue Team", screenW/2-240.0, botsize/3, GLUT_BITMAP_HELVETICA_18);
	drawtextGL("Red Team", screenW/2-70.0, botsize/3, GLUT_BITMAP_HELVETICA_18);

	drawtextGL(std::to_string((long double)scores[0]),screenW/2-140.0,botsize/3, GLUT_BITMAP_HELVETICA_18);
	drawtextGL(std::to_string((long double)scores[1]),screenW/2+25,botsize/3, GLUT_BITMAP_HELVETICA_18);

	

	//botset[0].angle = botset[0].angle + 10.0f; //counter clockwise rotation
	
	////////////kinect cursor select bots
	
	///////////// ROBOT section

	qobj = gluNewQuadric();
	
	//update desination	

	for (int i = 0; i < 2; i++)
	{
		for (int j = 0; j < 2; j++)
		{
			drawbotGL(team[i].botset[j],botsize,qobj);
		}		
	}
	
	//draw puck

	glColor3f(0,1.0f,0);

	glPushMatrix ();

	glTranslatef( puck1.X, puck1.Y, 5);
	gluQuadricNormals(qobj, GLU_FLAT);
	gluSphere(qobj,botsize/4,9,9);

	glPopMatrix ();
	

	//printf ("sel %d des1 %f,%f des2 %f,%f\nangle1 %f angle2 %f\n", mouseselectbot, 
	//		botset[0].dest.x, botset[0].dest.y, botset[1].dest.x, botset[1].dest.y,
	//		botset[0].angle, botset[2].angle);

	//////////////////////////////////////
	
	glColor3f(1.0f,0,0);

	glBegin(GL_LINE_STRIP);
	glVertex3f(0.0f, 0.0f, 0.0f);    // lower left vertex
	glVertex3f( 50.0f, 0.0f, 0.0f);    // lower right vertex	
	glEnd();

	glColor3f(0.0f,1.0f,0);

	glBegin(GL_LINE_STRIP);
	glVertex3f(0.0f, 0.0f, 0.0f);    // upper vertex
	glVertex3f( 0.0f, 50.0f, 0.0f);
	glEnd();

	glColor3f(0.0f,0,1.0f);

	glBegin(GL_LINE_STRIP);
	glVertex3f(0.0f, 0.0f, 0.0f);    // upper vertex
	glVertex3f( 0.0f, 0.0f, 50.0f);
	glEnd();

	
	//draw kinect cursor
	for (int iuse = 0; iuse<2; iuse++)
	{
	for (int ihand = 0; ihand<2; ihand++)
	{
		if (iPlayers[iuse].hands[ihand].isValid)
		{
			glPushMatrix ();
			glColor4f(abs(0.8f + -1.0*float(ihand)),abs(1.0f -1.0*float(iuse)), abs(0.7*float(iuse) -0.4*float(ihand)), 0.9f);
			
			glTranslatef(iPlayers[iuse].hands[ihand].drawX, iPlayers[iuse].hands[ihand].drawY, 0.2);

			//printf (iPlayers[iuse].hands[ihand].drawX, iPlayers[iuse].hands[ihand].drawY, 0.2);
			//printf("ihand %d, X %lf, Y %lf\n", 0, iPlayers[0].hands[0].X,  iPlayers[0].hands[0].Y);

			glBegin(GL_QUADS); 
			glVertex3f( botsize/2,  0, 0);
			glVertex3f(-botsize/2,  0, 0);
			glVertex3f(0, botsize/2, 0);
			glVertex3f( 0, -botsize/2, 0);
			glEnd();

			glPopMatrix ();
		}
	}
	}


	//score message	
	if (scoretimer >= 0 )
	{
		drawtextGL("SCORE!", screenW/2.0-50.0, screenH/2.0,  GLUT_BITMAP_TIMES_ROMAN_24 );
		scoretimer--;
	}


	//draw cursor

	// glColor4f(0.8f, 0, 0.8f, 0.5f);	
	// glPushMatrix ();
	// glTranslatef( mousepos.x-screenW/2, mousepos.y-screenH/2, 0);
	// gluQuadricNormals(qobj, GLU_FLAT);
	// gluSphere(qobj,botsize/4,9,9);
	// glPopMatrix ();

	//draw top corner
	glColor4f(1.0f, 1.0f, 1.0f, 0.5f);
	glPushMatrix ();

	glTranslatef( screenW *0.04, screenH *0.04, 0);

	gluQuadricNormals(qobj, GLU_FLAT);
	gluSphere(qobj,botsize/4,9,9);
	
	glPopMatrix ();
	gluDeleteQuadric(qobj);


	glutSwapBuffers();

	/*glViewport(0, 0, 320, 240);

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glOrtho(-32, 32, -24, 24, 50, -50); */  
}

//////////////////////////////////////////////////
void ftdiInitializer();// to initializer the robot
/* function to calculate checksum*/
unsigned char CheckSum(unsigned char * p, unsigned char len);//function to calculate checksum
cv::Mat GetThresholdFrame(cv::Mat frame);// fuction to get the threshold of the frame
double distanceOfPoints(double x1,double y1,double x2,double y2);// function to find the distance of two lines
std::string convertNum(double num);// function to convert number to string
void GetContours(int, void*);// function to find the contours of the object, then also find the coordinates, angles and center mass of the object
double angleSpeed(double theta1, double theta2);// rotation of the robot
bool angleCorrect(double theta1, double theta2);// to see if the angle is correct
double linearSpeed(double x1, double y1, double x2, double y2,double theta1, double theta2);// gives the linear speed of the robot
void GetLabel(cv::Mat drawing,double theta,std::vector<cv::Point2f> mc1,cv::Scalar color);// assign labels on the windows
void sendData(tPack data, double linVel,double angVel,unsigned char shoot,unsigned char ID);// send the data to the robot
void robotCommand(bool left,bool right, bool backward,bool forward,bool standby,double linVel,double angVel,double shoot,unsigned char ID);// give the instruction to robot
void robotSpeed(double dstLength, double robotDistance, double dstX, double dstY, double xPos, double yPos,double orientation, double orientation2, double theta, double theta2);// define the movemnet of the robot
void Getpixel(cv::Mat src);

void ftdiInitializer(){
	unsigned long NumDevices = 0, LocID = 0, ChipID = 0;
	printf("\n\nUSB <-> Serial Port\nFTDI-Device Finder\n");
	//printf("www.gfai.de/~heinz/techdocs\n");	
	//printf("Sources: FTDI-Appnotes and examples for D2XX\n\n");	

	FT_STATUS ftStatus;	
	FT_HANDLE fthandle;						
	FT_STATUS comp;							
	LONG COMPORT;							
	FT_DEVICE_LIST_INFO_NODE *devInfo;
	DWORD numDevs;

	// create the device information list
	ftStatus = FT_CreateDeviceInfoList(&numDevs);
		if (ftStatus == FT_OK) {
			printf("\nConnected USB Serial Port Device(s): %d\n\n",numDevs);
		}

		if (numDevs > 0) {

			// allocate storage for list based on numDevs
			devInfo = (FT_DEVICE_LIST_INFO_NODE*)malloc(sizeof(FT_DEVICE_LIST_INFO_NODE)*numDevs);

			// get the device information list
			ftStatus = FT_GetDeviceInfoList(devInfo,&numDevs);
			if (ftStatus == FT_OK) {
				for (int i = 0; i < (int) numDevs; i++) {
					//printf("Device %d:",i);

					// get the COMPORT-number
					comp = FT_Open(i, &fthandle);
						comp = FT_GetComPortNumber(fthandle,&COMPORT);
						printf("\nCOM%d\t", COMPORT);
					FT_Close(fthandle);

					// get the device informations
					printf("%s\n",devInfo[i].Description);
					printf("\tS/N \t%s\n",devInfo[i].SerialNumber);

					// Serial-Number Code Key:	XY_xxxxxx
					//	Version X:	1/2/3/...
					//				v1:  19	kBaud	FT232RL
					//				v2: 900 kBaud	FT232RL
					//				v3:  12 MBaud	FT232H
					//	Typ Y:	Simplex/Duplex/Uart (S/D/U)
					//	xxxxxx: auto-generated, individual
					// Examples: 1S_, 2U_, 3D_ ...

					//printf("\tFlags \t0x%x\n",devInfo[i].Flags);
					//printf("\tType \t0x%x\n",devInfo[i].Type);
					printf("\tID \t0x%x\n",devInfo[i].ID);
					printf("\tLocId \t0x%x\n",devInfo[i].LocId);
					//printf("\tftHandl\t0x%x\n",devInfo[i].ftHandle);
				}
			}
		free(devInfo);
		}
	//Initialize FTDI Connection
		if (((usb.OpenDevice(0)<0)||usb.SetDataCharacteristics(FT_BITS_8,FT_STOP_BITS_1,FT_PARITY_NONE)<0)||(usb.SetDeviceDataRate(FT_BAUD_4800)!=FT_OK))
		{
			//MessageBox (NULL, TEXT ("Error initializing device"), TEXT ("Error"), 0);
			//PostQuitMessage (0);
		}

	printf("\n\nHit any key to refresh the list\n");
	return;
}
cv::Mat GetThresholdFrame(cv::Mat frame){
	//convert color image to gray image
	cvtColor(frame,frame,CV_BGR2GRAY);
	Getpixel(frame);
	GaussianBlur(frame,frame,cv::Size(11,11),2,2);
	threshold(frame,frame,thresholdValue,255,cv::THRESH_BINARY);
	return frame;
}
double distanceOfPoints(double x1,double y1,double x2, double y2){
	//double xdif=0, ydif=0,xdifPow2=0,ydifPow2=0,distance=0;
	double distance=0;
	//xdif = x2-x1, ydif =y2-y1;
	//xdifPow2 = pow(xdif,2), ydifPow2 = pow(ydif,2);
	distance = sqrt(pow(x2-x1,2)+pow(y2-y1,2)); 


	return distance;
}
std::string convertNum(double num){
	std::stringstream convert;
	convert << num;
	return convert.str();
}
void GetLabel(cv::Mat drawing,double theta,std::vector<cv::Point2f> mc1,cv::Scalar color){
			 std::string angle = convertNum(theta);
			 std::string xPos = convertNum(mc1[0].x);
			 std::string yPos = convertNum(mc1[0].y);
			 cv::Point angleOrg(mc1[0].x-30,mc1[0].y-30);
			 cv::Point xPosOrg(mc1[0].x-30,mc1[0].y+30);
			 cv::Point yPosOrg(mc1[0].x+60,mc1[0].y+30);
			 putText(drawing,angle,angleOrg,1,1,color);//top
			 putText(drawing,xPos,xPosOrg,1,1,color);//left
			 putText(drawing,yPos,yPosOrg,1,1,color);//right

}
void GetContours(int min_approx,int max_approx,cv::Scalar color)
{	
	std::vector<std::vector<cv::Point>> contours;
	std::vector<cv::Point> approx;
	std::vector<cv::Vec4i> hierarchy;
	std::vector<cv::RotatedRect> minEllipse( contours.size() );
	findContours(src,contours,hierarchy,CV_RETR_TREE, CV_CHAIN_APPROX_SIMPLE, cv::Point(0, 0) );
	for(int i=0;i<contours.size();i++)
	{	double area=0;
		approxPolyDP(cv::Mat(contours[i]),approx,3,true);
		area = contourArea(contours[i]);
		std::vector<cv::Moments> mu(approx.size());//moment
		std::vector<cv::Point2f> mc(approx.size());//mass centers
		if((fabs(area)<areaThreshold) &&(min_approx==0))
		{
			mu[0] = moments(approx,true);
			mc[0] = cv::Point2f(mu[0].m10/mu[0].m00,mu[0].m01/mu[0].m00);
			Xpuck=mc[0].x;
			Ypuck=mc[0].y;
			circle( drawing, mc[0], 1, color, -1, 8, 0 );
			std::string xPos = convertNum(mc[0].x);
			std::string yPos = convertNum(mc[0].y);
			cv::Point xPosOrg(mc[0].x-30,mc[0].y+30);//down
			cv::Point yPosOrg(mc[0].x+60,mc[0].y+30);//up
			putText(drawing,xPos,xPosOrg,1,1,color);//left
			putText(drawing,yPos,yPosOrg,1,1,color);//right
		}
		else if((fabs(area)>areaThreshold) && (min_approx<=approx.size() && max_approx>=approx.size()))
		{	double xValue, yValue,xValuetemp, yValuetemp,xtemp,ytemp,distance,longestDis =0;
			//cout<<"Area: "<<area<<endl;
			mu[0] = moments(approx,true);
			mc[0] = cv::Point2f(mu[0].m10/mu[0].m00,mu[0].m01/mu[0].m00);
			circle( drawing, mc[0], 1,color, -1, 8, 0 );
			 drawContours( drawing, contours, i, color, 2, 8, hierarchy, 0, cv::Point());
			 for(int j=0; j<approx.size();j++)
			  {

				  distance = distanceOfPoints(mc[0].x,mc[0].y,approx[j].x,approx[j].y);
				  txPos = mc[0].x;
			      tyPos = mc[0].y;
				  if(distance >longestDis)
				  {
					  longestDis = distance;
					  xValuetemp = approx[j].x-mc[0].x;
					  yValuetemp = approx[j].y-mc[0].y;
				  }
			  }
			  trobotDistance = longestDis;
			  xValue = xValuetemp;
			  yValue = yValuetemp;
			//  cout<<"robotDistnace: "<<longestDis;
			  double theta = atan2(yValue,xValue);
			  theta = -(theta / PI) * 180;
			  torientation = (theta > 0) ? theta : theta+360;
			  torientation2=theta+180;
			  theta = torientation;//the cat jumps over the fox
			  GetLabel(drawing,theta,mc,color);	

		}
	}
}
double angleSpeed(double theta1, double theta2){

	double angleRange1 = theta2*0.9;
	double angleRange2 = theta2*1.1;
	double angVel=0;
	if ((theta1 >= angleRange1)&&(theta1 <= angleRange2)){
		angVel = 0;
	}
	if((theta1 < angleRange1)||(theta1 > angleRange2))
	{
		if(abs(theta1 - theta2)<180)
		{
			if((theta1-theta2)>0)
			{
				angVel = 120;		
			}//angry birds
			if((theta1-theta2)<0)
			{
				angVel = -120;
			}
		}
		else
		{
			angVel = 120;
		}
	}		
    return angVel;
}
bool angleCorrect(double theta1, double theta2){
	double angleRange1 = theta2*0.9;
	double angleRange2 = theta2*1.1;
	bool angleMatch = false;
	if ((theta1 >= angleRange1)&&(theta1 <= angleRange2)){
		angleMatch = true;
	}
	if((theta1 < angleRange1)||(theta1 > angleRange2)){

		angleMatch = false;
	}
	return angleMatch;
}
double linearSpeed(double x1, double y1, double x2, double y2,double theta1, double theta2){
	bool linearMatch = false;
	double xRange1 = x2*0.95;
	double xRange2 = x2*1.05;
	double yRange1 = y2*0.95;
	double yRange2 = y2*1.05;
	double linVel = 0;

	bool angleMatch = angleCorrect(theta1,theta2);
	if(angleMatch == true){
		linVel = 120;
		if (((x1 >= xRange1)&&(x1 <= xRange2)) && ((y1>=yRange1)&&(y1 <= yRange2))){
			linVel = 0;					
		}	
		else if (((x1 < xRange1)||(x1 > xRange2)) || ((y1<yRange1)||(y1 > yRange2))){
			linVel = 120;
			shoot  = 0x01;//rainbow pot of gold
		}
	}
	return linVel;
}

void robotSpeed(double dstLength, double robotDistance, double dstX, double dstY, double xPos, double yPos,double orientation, double orientation2, double theta, double theta2)
{
	if (((dstLength > robotDistance)&&(dstX<=xPos))||((dstLength > robotDistance)&&(dstX>xPos)&&(dstY>yPos)))
	{
		angVel = angleSpeed(orientation,theta);
		shoot  = 0x01;
	}
	else if((dstLength > robotDistance)&&(dstX>xPos)&&(dstY<=yPos))
	{
		angVel=angleSpeed(orientation2,theta2);
		shoot  = 0x01;
	}
	else
	{
		angVel = 0;
	}
	//moving
	//TODO verify robotDistance1
	if((dstLength > robotDistance1)&&(dstX>xPos)&&(dstY<=yPos))
	{
		linVel = linearSpeed(xPos,yPos,dstX,dstY,orientation2,theta2);
		shoot  = 0x01;
	}
	else if((dstLength > robotDistance1)&&(dstX<=xPos)&&(dstY>yPos))
	{
		linVel = linearSpeed(xPos,yPos,dstX,dstY,orientation,theta);
		shoot  = 0x01;
	}
	else
	{
		linVel = linearSpeed(xPos,yPos,dstX,dstY,orientation,theta);
		if(dstLength > robotDistance)
		{
			shoot  = 0x01;
		}
		else
		{
			shoot =0x11;
		}
	}
}

void sendData(double linVel,double angVel,unsigned char shoot,unsigned char ID)
{   tPack data;
	data.start = 0xAA;
	data.ID = ID;//5 sides
	data.commd = shoot;
	data.v = linVel;
	data.w = angVel;
	data.checksum = CheckSum((unsigned char *)&data+1, 0x06);
	data.end = 0x55;
	usb.WriteToDevice((unsigned char*)&data,sizeof(data));

}
void robotCommand(bool left,bool right, bool backward,bool forward,bool standby,double linVel,double angVel,double shoot,unsigned char ID)
{
	
	if( left == true)
	{
		sendData(0,-120,0x01,ID);
	}
	else if( right == true)
	{
		sendData(0,120,0x01,ID);
	}
	else if( forward ==true)
	{
		sendData(120,0,0x01,ID);
	}
	else if(backward == true)
	{
		sendData(-120,0,0x01,ID);
	}
	else if(standby==true)
	{
		sendData(0,0,0x01,ID);
	}
	else
	{
		sendData(linVel,angVel,shoot,ID);
	}
}
void Getpixel(cv::Mat frame)
{	
	std::ofstream outFile;         // Step #2 - Declare outstream file.

   outFile.open("C:/Users/khchu/Documents/Visual Studio 2010/Projects/test2/test.txt");        // Step #3 - Open outFile.

   if (outFile.fail())          // Check for file creation and return error.
   {
      //std::cout << "Error opening \"numbers.txt\" for output.\n";

      return;
   }
	cv::Scalar intensity;
	std::string str = "" ;
	imwrite("C:/Users/khchu/Documents/Visual Studio 2010/Projects/test2/Test Images/Image1.jpeg", frame);
	for(int row = 0; row < 480; row++)
	{
		for(int col = 0; col < 640; col++)
		{	
			intensity =frame.at<uchar>(row,col);
			float value = intensity.val[0];
			outFile << value;
			outFile << " ";
			
		}
	}
	 outFile.close(); 
}

void KinectRead()
{
	if(WAIT_OBJECT_0 == WaitForSingleObject(depthEvent, 0))
	{
		//ProcessDepth(depthHandle, sensor, cvImageDepth, depthBuffer, interactionStream);
		ProcessDepth(cvImageDepth, depthBuffer, depthHandle, sensor, interactionStream );

	}
	if(WAIT_OBJECT_0 == WaitForSingleObject(skeletonEvent, 0))
	{
		//ProcessSkeleton(sensor, interactionStream, cvImageColor);
		ProcessSkeleton(cvImageDepth, SkeletonPts, sensor, interactionStream);
	}
	if(WAIT_OBJECT_0 == WaitForSingleObject(interactionEvent, 0))
	{
		//DWORD skeletonTrackingId;
		//NUI_HAND_TYPE handType;
		//FLOAT x, y;
		//NUI_INTERACTION_INFO pInteractionInfo;
		//client->GetInteractionInfoAtLocation(skeletonTrackingId, &handType, &x, &y, &pInteractionInfo);
		//printf("interaction event\n");
		ProcessInteraction(interactionStream, iPlayers);
	}	
}

void KinectPosition()
{
	double tempX, tempY;
	bot *ptrbotset;
	
	////////////kinect cursor select bots
	for (int iuse = 0; iuse<2; iuse++)
	{
		int ihand = 1;
	//for (int ihand = 0; ihand<2; ihand++)
	//{
		if (iPlayers[iuse].hands[ihand].isValid)
		{
			//assign teams to specific user or hand
			ptrbotset = team[iuse].botset;
			//ptrbotset = team[ihand].botset;

			iPlayers[iuse].hands[ihand].drawX = (iPlayers[iuse].hands[ihand].X + 0.5)*320.0;
			iPlayers[iuse].hands[ihand].drawY = (iPlayers[iuse].hands[ihand].Y + 0.5)*240.0;

			if (iPlayers[iuse].hands[ihand].drawX > screenW)
				iPlayers[iuse].hands[ihand].drawX = screenW;
			if (iPlayers[iuse].hands[ihand].drawX < 0)
				iPlayers[iuse].hands[ihand].drawX = 0;
			if (iPlayers[iuse].hands[ihand].drawY > screenH)
				iPlayers[iuse].hands[ihand].drawY = screenH;
			if (iPlayers[iuse].hands[ihand].drawY < 0)
				iPlayers[iuse].hands[ihand].drawY = 0;	
			
			if (iPlayers[iuse].hands[ihand].doGrip == true)
				//&& iPlayers[iuse].hands[ihand].didGrip == false)
			{					
				for( int i = 0; i<2; i++)
				{	
					//reset position button
					tempX = iPlayers[iuse].hands[ihand].drawX;// 
					tempY = iPlayers[iuse].hands[ihand].drawY;// 

					if ( tempX >= (screenW - botsize/1.5) && tempY <= botsize/1.5
						&& iPlayers[iuse].hands[ihand].selectbot == botNONE )
					{
						initGame();
					}

					//reset score button
					if ( tempX >= (screenW - botsize/1.5) && tempY >= (screenH - botsize/1.5)
						&& iPlayers[iuse].hands[ihand].selectbot == botNONE )
					{
						scores[0]=0;
						scores[1]=0;
					}
										
					tempX = ptrbotset[i].X - iPlayers[iuse].hands[ihand].drawX;// - screenW/2);
					tempY = ptrbotset[i].Y - iPlayers[iuse].hands[ihand].drawY;// - screenH/2);

					if ( (tempX*tempX + tempY*tempY) < botsize*botsize/4
						&& iPlayers[iuse].hands[ihand].selectbot == botNONE )
					{
						iPlayers[iuse].hands[ihand].selectbot = i;
						ptrbotset[i].highlight = true;
					}
				}             
			}
			else
			{
				if (iPlayers[iuse].hands[ihand].selectbot != botNONE)
				{
					ptrbotset[iPlayers[iuse].hands[ihand].selectbot].highlight = false;
				}

				iPlayers[iuse].hands[ihand].selectbot = botNONE;
			}

			int selectbotI = iPlayers[iuse].hands[ihand].selectbot;
			if (selectbotI != botNONE)
			{
				ptrbotset[selectbotI].destX = iPlayers[iuse].hands[ihand].drawX;
				ptrbotset[selectbotI].destY = iPlayers[iuse].hands[ihand].drawY;
			}
		}
	//}
	}	
}

void KinectDraw(cv::Mat image)
{
	cv::Scalar cursorColor;
	cv::Point pt;
	int selectbotI;
	
	std::string xPos;
	std::string yPos;
	CvPoint xPosOrg;//down
	CvPoint yPosOrg;//up
	
	//draw kinect cursor
	for (int iuse = 0; iuse<2; iuse++)
	{
	for (int ihand = 0; ihand<2; ihand++)
	{
		if (iPlayers[iuse].hands[ihand].isValid)
		{
			cursorColor = cv::Scalar(abs(100 + -255*ihand),abs(255 -255*iuse), abs(50 -1.0*ihand));
			pt = cvPoint(iPlayers[iuse].hands[ihand].drawX, iPlayers[iuse].hands[ihand].drawY);
						
			cv::circle(image, pt, 10,  cursorColor, -5);
			
			//selectbotI = iPlayers[iuse].hands[ihand].selectbot;
			//if ( selectbotI != botNONE)
			//{
			//	pt = cvPoint(team[iuse].botset[selectbotI].X, team[iuse].botset[selectbotI].Y);
			//	cv::circle(image, pt, 7,  cursorColor, -3);

			//	/*pt = cvPoint(botset[botNONE].destX, botset[botNONE].destY);
			//	cv::circle(image, pt, 3,  cursorColor, -3);*/
			//}
		}
	}
	}	
	
	xPosOrg = cvPoint(1,25);//down
	putText(image,"L",xPosOrg,1,1.5,cv::Scalar(255, 255, 255));//left
	xPosOrg = cvPoint(1,25+30);//down
	putText(image,"R",xPosOrg,1,1.5,cv::Scalar(255, 255, 255));//right
	
	xPosOrg = cvPoint(10,25);//down
	xPos = convertNum(iPlayers[0].hands[0].doGrip);
	putText(image,xPos,xPosOrg,1,1.5,cv::Scalar(255, 255, 255));//left
	xPosOrg = cvPoint(10,25+30);//down
	xPos = convertNum(iPlayers[0].hands[1].doGrip);
	putText(image,xPos,xPosOrg,1,1.5,cv::Scalar(255, 255, 255));//right

	xPos = convertNum(iPlayers[0].hands[0].drawX);
	yPos = convertNum(iPlayers[0].hands[0].drawY);
	xPosOrg = cvPoint(30,25);//down
	yPosOrg = cvPoint(30+150,25);//up
	putText(image,xPos,xPosOrg,1,2,cv::Scalar(255, 255, 255));//left
	putText(image,yPos,yPosOrg,1,2,cv::Scalar(255, 255, 255));//right

	xPos = convertNum(iPlayers[0].hands[1].drawX);
	yPos = convertNum(iPlayers[0].hands[1].drawY);
	xPosOrg = cvPoint(30,25+30);//down
	yPosOrg = cvPoint(30+150,25+30);//up
	putText(image,xPos,xPosOrg,1,2,cv::Scalar(255, 255, 255));//left
	putText(image,yPos,yPosOrg,1,2,cv::Scalar(255, 255, 255));//right
}


///////////////////////

//opengl stuff

void VectorAdd(float speed1, float angle1, float speed2, float angle2, float &final_speed,float &final_angle)
{
	float speed_x;
	float speed_y;
	speed_x = cos(angle1/180*PI)*speed1 + cos(angle2/180*PI)*speed2;
	speed_y = sin(angle1/180*PI)*speed1 + sin(angle2/180*PI)*speed2;
	final_angle = atan2(speed_y,speed_x)/PI*180;
	final_speed = sqrt(pow(speed_x,2)+pow(speed_y,2));
}

//opengl stuff

void PuckMove(puck &puck1)
{
	/*------------------Boundary Collision Detection--------------------*/
	// Collision Detection for Top and Bottom boundary
	//if ((puck1.Y > screenH/2)||(puck1.Y < -screenH/2))
	//	puck1.angle = 0 - puck1.angle;
	if (puck1.Y > screenH)
	{
		puck1.Y = screenH;
		puck1.angle = 0 - puck1.angle;
	}
	if (puck1.Y < 0)
	{
		puck1.Y = 0;
		puck1.angle = 0 - puck1.angle;
	}


	if (puck1.X <= 0)
	{
		if ( puck1.Y< (screenH/2 + botsize) && puck1.Y> (screenH/2 - botsize))
		{
			scores[1] += 1;
			scoretimer = 45;
			initGame();
			/*if (puck1.speed >1)
				puck1.speed =1;*/
		}
		else
		{
			puck1.X = 0;
			puck1.angle = 180 - puck1.angle;
		}
	}

	if (puck1.X >= screenW)
	{
		if ( puck1.Y< (screenH/2 + botsize) && puck1.Y> (screenH/2 - botsize))
		{
			scores[0] += 1;
			scoretimer = 45;
			initGame();
			//if (puck1.speed >1)
			//	puck1.speed =1;
		}
		else
		{
			puck1.X = screenW;
			puck1.angle = 180 - puck1.angle;
		}
	}

	if (puck1.angle >= 360)
		puck1.angle -=360;
	if (puck1.angle <= -360)
		puck1.angle += 360;

	/*--------------------Generate New Position---------------------*/
	if (puck1.speed >0)
	{
		puck1.X += puck1.speed * cos(puck1.angle *PI/180);
		puck1.Y += puck1.speed * sin(puck1.angle *PI/180);
	}

	/*----------------------Generate New Speed----------------------*/
	if (puck1.speed > 0.1)
		puck1.speed -= Friction_coeff;
	else
		puck1.speed = 0;
}

//opengl stuff

//This function detects if the puck collides with a robot, if the collision happened, the puck will change its orientation.
//Also the robot's current speed will be counted into the new velocity/orientation
void PuckBotCollide(bot &robot, puck &puck1)
{
	int collision_face = 0;	// 1 front 2 left 3 back 4 right
	float collang;
	float new_speed;
	float new_angle;
	//static int counter[2] = {0,0};
	int counter = 0;

	//Determine which face does the collision occurs, if collision did not occur, collision_face = 0
	tempX = puck1.X-robot.X;
	tempY = puck1.Y-robot.Y;
	if ( (tempX*tempX + tempY*tempY) < 	(puck1.radius + botsize*.75)*(puck1.radius + botsize*.75)	)	//Collision occurs
	{
		collang = robot.angle - atan2f((puck1.Y-robot.Y),(puck1.X-robot.X))/PI*180 ;
		while (collang > 360)
			collang -= 360;
		while (collang < 0)
			collang += 360;
		//cout <<"collang"<<collang<<endl;
		if ((collang >=45)&&(collang <135))
			collision_face = 4;
		else if ((collang >=135)&&(collang <225))
			collision_face = 3;
		else if ((collang >=225)&&(collang <315))
			collision_face = 2;
		if (((collang >=0)&&(collang <45))||((collang >=315)&&(collang <360)))
			collision_face = 1;
	}

/*--------------------Get Speed & Angle after Collision-----------------*/
	switch(collision_face)
	{
		case 1:
		{
			if (robot.destX - robot.X !=0 && robot.destY - robot.Y !=0)
			{
				if (counter == 0)
				{
					puck1.angle = (180 - puck1.angle)+2*robot.angle;
					VectorAdd(puck1.speed,puck1.angle,  Collide_force,robot.angle,new_speed,new_angle);
					puck1.speed = new_speed;
					puck1.angle = new_angle;
				}
				counter = 1;
				//cout<<"final speed="<<puck1.speed<<" final angle="<<puck1.angle<<endl;
			}
			else //if (robot.go_forward == 0)
			{
				puck1.angle = (180 - puck1.angle)+2*robot.angle;
				//cout<<"final speed="<<puck1.speed<<" final angle="<<puck1.angle<<endl;
			}
			break;
		}
		case 3:
		{
			if (robot.destX - robot.X !=0 && robot.destY - robot.Y !=0)
			{
				if (counter == 0)
				{
					puck1.angle = (180 - puck1.angle)+2*(robot.angle-180);
					VectorAdd(puck1.speed,puck1.angle,Collide_force,robot.angle,new_speed,new_angle);
					puck1.speed = new_speed;
					puck1.angle = new_angle;
				}
				counter = 1;
				//cout<<"final speed="<<puck1.speed<<" final angle="<<puck1.angle<<endl;
			}
			else //if (robot.go_forward == 0)
			{
				puck1.angle = (180 - puck1.angle)+2*(robot.angle);
				//cout<<"final speed="<<puck1.speed<<" final angle="<<puck1.angle<<endl;
			}
			break;
		}
	case 4:
		{
			if (counter == 0)
			{
				puck1.angle = (180 - puck1.angle)+2*(robot.angle-90);
				//cout<<"final speed="<<puck1.speed<<" final angle="<<puck1.angle<<endl;
			}
			counter = 1;
			break;
		}
		case 2:
		{
			if (counter == 0)
			{
				puck1.angle = (180 - puck1.angle)+2*(robot.angle-90);
				//cout<<"final speed="<<puck1.speed<<" final angle="<<puck1.angle<<endl;
			}
			counter = 1;
			break;
		}
	}
	if (puck1.speed > Kick_force*1.5)
		puck1.speed = Kick_force*1.5;
}

//opengl stuff

void botmove(bot &robot)
{
	if (robot.angVel != 0.0)
	{
		robot.angle = robot.angle+ robot.angVel;

		if (robot.angle < 0)
		{	robot.angle += 360.0;}
		else if (robot.angle >= 360)
		{	robot.angle -=360.0;}
	}
	else if ( robot.velocity != 0.0)
	{
		double tempA = robot.angle*PI/180.0;
			
		robot.X = robot.X + robot.velocity *cos(tempA);
		robot.Y = robot.Y + robot.velocity *sin(tempA);		
	}

	//boundary condition
	if (robot.X > screenW)
		robot.X = screenW;
	if (robot.X < 0)
		robot.X = 0;
	if (robot.Y > screenH)
		robot.Y = screenH;
	if (robot.Y < 0)
		robot.Y = 0;
}

double angleSpeedV(double &thetaSource, double &thetaDest)
{
	/*double angleRange1 = thetaDest-2;
	double angleRange2 = thetaDest+2;*/
	double angVel = 0.0;

	double angleDiff= thetaDest - thetaSource;
	if (angleDiff < 0)
		angleDiff += 360.0;
	else if (angleDiff >= 360.0)
		angleDiff -= 360.0;

	//if ((thetaSource >= angleRange1)&&(thetaSource <= angleRange2)){
	if (angleDiff <= 4.0 || angleDiff > 360.0 - 4.0 )
	{
		angVel = 0.0;
	}
	else// if((thetaSource < angleRange1)||(thetaSource > angleRange2))
	{
		if(angleDiff<180)
		{
			angVel = 7.5;
		}
		else
		{
			angVel = -7.5;
		}
	}		
    return angVel;
}
bool angleCorrectV(double &thetaSource, double &thetaDest){
	double angleRange1 = thetaDest-2;
	double angleRange2 = thetaDest+2;
	bool angleMatch = false;
	if ((thetaSource >= angleRange1)&&(thetaSource <= angleRange2)){
		angleMatch = true;
	}
	else //if((thetaSource < angleRange1)||(thetaSource > angleRange2))
	{
		angleMatch = false;
	}
	return angleMatch;
}
double linearSpeedV(double &x1, double &y1, double &x2, double &y2)//,double &thetaSource, double &thetaDest)
{
	bool linearMatch = false;
	double xRange1 = x2*0.95;
	double xRange2 = x2*1.05;
	double yRange1 = y2*0.95;
	double yRange2 = y2*1.05;
	double linVel = 0;

	//bool angleMatch = angleCorrectV(thetaSource,thetaDest);
	//if(angleMatch == true)
	//{
		//linVel = 120;
		linVel = 5.0;
		if (((x1 >= xRange1)&&(x1 <= xRange2)) && ((y1>=yRange1)&&(y1 <= yRange2))){
			linVel = 0;					
		}	
		else //if (((x1 < xRange1)||(x1 > xRange2)) || ((y1<yRange1)||(y1 > yRange2)))
		{
			//linVel = 120;
			linVel = 5.0;
		}
	//}
	return linVel;
}

void robotSpeedV(bot &robot1, double robotDistance)
{
	double angVel = 0, lineVel = 0;

	double dstLength = distanceOfPoints(robot1.X,robot1.Y,robot1.destX,robot1.destY);	

	double theta = atan2(robot1.destY-robot1.Y,robot1.destX-robot1.X);
	//theta = -(theta / PI) * 180.0;
	theta = (theta / PI) * 180.0;
	theta = (theta > 0) ? theta : theta+360.0;// if theata>0 stay the same else theata+360
	double theta2= theta+180.0;	
	
	double orientation = robot1.angle;
	double orientation2 = orientation + 180.0;

	if (dstLength > robotDistance)
	{
		angVel = angleSpeedV(orientation,theta);
	}
	else
	{
		angVel = 0.0;
	}
	//moving
	//TODO verify robotDistance1
	if((dstLength > robotDistance)&&(angVel == 0.0))
	{
		linVel = linearSpeedV(robot1.X,robot1.Y,robot1.destX,robot1.destY);
	}
	else
	{
		linVel = 0.0;
	}

	robot1.velocity = linVel;
	robot1.angVel = angVel;
}


//////////////////

int main(int argc, char *argv[])
{
	//printf("atan2(1,0) %f, atan2(0,1) %f", atan2(1.0,0.0),atan2(0.0,1.0));
	//GL stuff
	glutInit(&argc, argv);

	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB |GLUT_DEPTH);
	
	//table size is 120 x 60
	glutInitWindowSize(screenW, screenH);
	//glutSetOption(GLUT_ACTION_ON_WINDOW_CLOSE, GLUT_ACTION_CONTINUE_EXECUTION);

	//glutInitWindowSize(1024, 576);

	//glutInitWindowSize(640 , 360);

	// create the first window
	window1 = glutCreateWindow("Game Window");
	// register callbacks for first window, which is now current
	//glutReshapeFunc(window1_reshape);
	//glutDisplayFunc(drawSceneDUAL);
	glutDisplayFunc(drawSceneWIDE);
	
	///////////////////
	//glutKeyboardFunc(glutKeyboard);
	//glutMouseFunc(glutMouse);
	//glutPassiveMotionFunc(glutPassMotion);
	//glutMotionFunc(glutMotion);//*/
	///////////////////

	doInit();
	//glutReshapeFunc(reshapeGlut);

	glutIdleFunc(glutIdle);  //idle function is not associated with a window
	//glutMainLoop();

	//////////////////////////////////////////////////////
	
	//kinect start
	iPlayers[0].init();
	iPlayers[1].init();
	
	team[0].init();
	team[1].init();
	
	initGame();	
	
	//kinect init
	HRESULT hr = S_OK;

    // m_IplImage = FTCreateImage();    

    hr = NuiCreateSensorByIndex( 0, &sensor );
    if( FAILED( hr ) ){
        std::cerr << "Error : NuiCreateSensorByIndex" << std::endl;
        return -1;
    }  

    // Sensor Initialize
    hr = sensor->NuiInitialize( NUI_INITIALIZE_FLAG_USES_COLOR | NUI_INITIALIZE_FLAG_USES_DEPTH_AND_PLAYER_INDEX |NUI_INITIALIZE_FLAG_USES_SKELETON );
    if( FAILED( hr ) ){
        std::cerr << "Error : INuiSensor::NuiInitialize" << std::endl;
        return -1;
    }
    // Depth Stream Open
    //HANDLE 
	depthHandle = INVALID_HANDLE_VALUE;
    //HANDLE 
	depthEvent = CreateEvent( nullptr, true, false, nullptr );
    hr = sensor->NuiImageStreamOpen( NUI_IMAGE_TYPE_DEPTH_AND_PLAYER_INDEX, NUI_IMAGE_RESOLUTION_640x480, 0, 2, depthEvent, &depthHandle );
    if( FAILED( hr ) ){
        std::cerr << "Error : INuiSensor::NuiImageStreamOpen( DEPTH )" << std::endl;
        return -1;
    }
    // Enable Skeleton Tracking 
    //HANDLE 
	skeletonEvent = CreateEvent( nullptr, true, false, nullptr );
    hr = sensor->NuiSkeletonTrackingEnable( skeletonEvent, 0 );
    if( FAILED( hr ) ){
        std::cerr << "Error : INuiSensor::NuiSkeletonTrackingEnable" << std::endl;
        return -1;
    }
    // Create Interaction Stream and Enable    
    CIneractionClient* interclient = new CIneractionClient();
    hr = NuiCreateInteractionStream( sensor, interclient, &interactionStream );
    if( FAILED( hr ) ){
        std::cerr << "Error : NuiCreateInteractionStream" << std::endl;
        return -1;
    }
    //HANDLE 
	interactionEvent = CreateEvent( nullptr, true, false, nullptr );
    hr = interactionStream->Enable(interactionEvent);
    if( FAILED( hr ) )
    {
      std::cout<<"Could not open Interation stream video"<< std::endl;
        return -1;
    }

    HANDLE events[4] = { colorEvent, depthEvent, skeletonEvent, interactionEvent};
////////////////////////////////////////////////

	// open the camera
	cv::VideoCapture cap(0);
	if(!cap.isOpened())
		return -1;
	//initializer the robot
	ftdiInitializer();
	//declare the variables
	double dstX,dstY = 0;
	double dstX1,dstY1,dstX2,dstY2,dstX3,dstY3 = 0;
	double defX2 = 220;
	double defY2 = 164;
	double defX1 = 96;
	double defY1 = 294;
	double defX3 = 266;
	double defY3 = 359;
	bool attack  = true;
	bool defence = false;
	bool attack1 = true;
	bool attack2 = true;
	bool defence1 = false;
	bool defence2 = false;
	bool attack3 = true;
	bool defence3= false;
	bool forward1=false,backward1=false,right1=false,left1=false;
	bool forward2=false,backward2=false,right2=false,left2=false;
	bool forward3=false,backward3=false,right3=false,left3=false;
	bool standby1=false,standby2 =false,standby3=false;
	double theta, theta2, theta3, theta4,dstLength2, dstLength1=0;
	double theta5,theta6,dstLength3=0;
	tPack data;
	
	
	dstX1 = defX1;
	dstY1 = defY1;
	dstX2 = defX2;
	dstY2 = defY2;
	dstX3 = defX3;
	dstY3 = defY3;
	
	// botset[0].destX = dstX1;
	// botset[0].destY = dstY1;
	// botset[1].destX = dstX2;
	// botset[1].destY = dstY2;	
	//botset[2].destX = dstX3;
	//botset[2].destY = dstY3;
	/*team[0].botset[0].destX = dstX1;
	team[0].botset[0].destY = dstY1;
	team[0].botset[1].destX = dstX2;
	team[0].botset[1].destY = dstY2;*/
		

	// open the continue loop for the frame
	for(;;)
	{	
		// declare the variable and read it 
		cv::Mat frame;
		cap>> frame;

		KinectRead();
		
		// image processing of the image and show it 
		src= GetThresholdFrame(frame);
		//Getpixel(src);
		cv::namedWindow("threshFrame",CV_WINDOW_AUTOSIZE);
		imshow("threshFrame",src);
		//show the source of the image in a new window
		cv::namedWindow( "Source", CV_WINDOW_AUTOSIZE );
		imshow( "Source", frame );
		imwrite("C:/Users/khchu/Documents/Visual Studio 2010/Projects/test2/Test Images/Image2.jpeg", src);
		drawing = cv::Mat::zeros( src.size(), CV_8UC3 );
		//Shape recongization
		GetContours(0,0,color1);//the puck
		// 6 sizes
		GetContours(3,3,color2);
		orientation = torientation;// get the angles
		orientation2 = torientation2;
		robotDistance1= trobotDistance;// get the distances
		yPos1 = tyPos;// get the coordinates
		xPos1 = txPos;
		team[0].botset[0].X = txPos;
		team[0].botset[0].Y = tyPos;
		team[0].botset[0].angle = -orientation;
		//5 sizes
		GetContours(10,13,color3);
		orientation3 = torientation;
		orientation4 = torientation2;
		robotDistance2 = trobotDistance;
		yPos2 = tyPos;
		xPos2 = txPos;
		team[0].botset[1].X = txPos;
		team[0].botset[1].Y = tyPos;
		team[0].botset[1].angle = -orientation3;
		//4sizes
		GetContours(7,9,color4);
		orientation5 = torientation;
		orientation6 = torientation2;
		robotDistance3 = trobotDistance;
		yPos3 = tyPos;
		xPos3 = txPos;
		//botset[2].X = txPos;
		//botset[2].Y = tyPos;
				
		cv::namedWindow( "kinect", CV_WINDOW_AUTOSIZE );
		imshow("kinect",cvImageDepth); 
		
		KinectPosition();
		KinectDraw(drawing);
		glutPostRedisplay();//drawSceneWIDE();
		glutMainLoopEvent();
		
		
		//show the image
		cv::namedWindow( "Contours", CV_WINDOW_AUTOSIZE );
		imshow( "Contours", drawing );
		
		dstX1 = team[0].botset[0].destX;// = dstX1;
		dstY1 = team[0].botset[0].destY;// = dstY1;
		dstX2 = team[0].botset[1].destX;// = dstX2;
		dstY2 = team[0].botset[1].destY;// = dstY2;
		
		// dstX1 = botset[0].destX;
		// dstY1 = botset[0].destY;
		// dstX2 = botset[1].destX;
		// dstY2 = botset[1].destY;
		// dstX3 = botset[2].destX;
		// dstY3 = botset[2].destY;	
	
		PuckMove(puck1);
		for (int j = 0; j < 2; j++)
		{
			robotSpeedV(team[1].botset[j], botsize/2.0);				
			botmove(team[1].botset[j]);

			for (int i = 0; i < 2; i++)
			{			
				PuckBotCollide(team[i].botset[j], puck1);
			}
		}		
		
		// set the coordinates of the dst as the corrdinates of the puck
		//dstX = Xpuck;
		//dstY = Ypuck;
		// different commands have different dst
		// if(attack1 == true)
		// {
			// dstX1 = dstX;
			// dstY1 = dstY;
		// }
		// else if(defence1 == true)
		// {
			// dstX1 = defX1;
			// dstY1 = defY1;
		// }
		
		// if(attack2 == true)
		// {
			// dstX2 = dstX;
			// dstY2 = dstY;
		// }
		// else if( defence2 == true)
		// {
			// dstX2 = defX2;
			// dstY2 = defY2;
		// }
		// if( attack3 ==true)
		// {
			// dstX3 = dstX;
			// dstY3 = dstY;
		// }
		// else if(defence == false)
		// {
			// dstX3 = defX3;
			// dstY3 = defY3;
		// }
		// the angles for 6 sizes shape
		theta = atan2(dstY1-yPos1,dstX1-xPos1);
		theta = -(theta / PI) * 180;
		theta = (theta > 0) ? theta : theta+360;// if theata>0 stay the same else theata+360
		theta2= theta+180;
		dstLength1 = distanceOfPoints(xPos1,yPos1,dstX1,dstY1); // find the distance between the robot and the dst
		// the angles for 5 sizes shape
		theta3 = atan2(dstY2-yPos2,dstX2-xPos2);
		theta3 = -(theta3 / PI) * 180;
		theta3 = (theta3 > 0) ? theta3 : theta3+360;// if theata>0 stay the same else theta+360
		theta4 = theta3 + 180;
		dstLength2 = distanceOfPoints(xPos2,yPos2,dstX2,dstY2);
		// the angles for 4 sizes shape
		theta5 = atan2(dstY3-yPos3,dstX3-xPos3);
		theta5 = -(theta5 / PI) * 180;
		theta5 = (theta5 > 0) ? theta5 : theta5+360;// if theata>0 stay the same else theta+360
		theta6 = theta5 + 180;
		dstLength3 = distanceOfPoints(xPos3,yPos3,dstX3,dstY3);

		robotSpeed(dstLength1,robotDistance1,dstX1,dstY1,xPos1,yPos1,orientation,orientation2,theta,theta2); // 6sides
		
		if(defence1 == true)
		{
			shoot = 0x01;
		}
		robotCommand(left1,right1,backward1,forward1,standby1,linVel,angVel,0,0xCB); // send the command according to the command
		robotSpeed(dstLength2,robotDistance2,dstX2,dstY2,xPos2,yPos2,orientation3,orientation4,theta3,theta4); // 5sides
		if(defence2 == true)
		{
			shoot = 0x01;
		}
		robotCommand(left2,right2,backward2,forward2,standby2,linVel,angVel,0,0xBB);

	   robotSpeed(dstLength3,robotDistance3,dstX3,dstY3,xPos3,yPos3,orientation5,orientation6,theta5,theta6); // 4sides
	   if(defence3 == true)
		{
			shoot = 0x01;
		}
	   robotCommand(left3,right3,backward3,forward3,standby3,linVel,angVel,0,0xAB);
	   // the part below let the user to gives commands to the robot by pressing certain key
		int char_code = cv::waitKey(60);
		if(char_code == 32) // spacebar - pause
			{
				sendData(0,0,0x01,0xCB);
				sendData(0,0,0x01,0xBB);
				sendData(0,0,0x01,0xAB);
				std::cout<< " the Game is pause. Press spaceba to resume the game"<<std::endl;
				int continue_key_code = cv::waitKey(45);
				while(continue_key_code != 32)
					{
						continue_key_code = cv::waitKey(45);
					}
			}
		else if(char_code == 48)//0 - end the program
		{
			cv::destroyAllWindows();
			return 0;
		}
		else if(char_code == 101)//e - defence at certain position
		{	standby1 = false;
			forward1 = false;
			backward1= false;
			right1   = false;
			left1    = false;
			attack1= false;
			defence1= true;
			shoot = 0x01;
			std::cout<<"6sides robot defence "<<std::endl;
		}
		else if(char_code == 113)//q - chase the puck
		{	standby1 = false;
			forward1 = false;
			backward1= false;
			right1   = false;
			left1    = false;
			attack1= true;
			defence1= false;
			shoot = 0x01;
			std::cout<<"6sides robot attacks "<<std::endl;
		}
		else if(char_code == 119)//w - forward
		{	standby1 = false;
			forward1 = true;
			backward1= false;
			right1   = false;
			left1    = false;
			attack1  = false;
			defence1 = false;
			std::cout<<"6sides moving forwards "<<std::endl;
		}
		else if(char_code == 115)//s - stop
		{	standby1 = true;
			forward1 = false;
			backward1= false;
			right1   = false;
			left1    = false;
			attack1  = false;
			defence1 = false;
			std::cout<<"6sides robot stops "<<std::endl;
		}
		else if(char_code ==120)//x - backward
		{
			standby1 = false;
			forward1 = false;
			backward1= true;
			right1   = false;
			left1    = false;
			attack1  = false;
			defence1 = false;
			std::cout<<"6sides robot moving backward "<<std::endl;
		}
		else if(char_code == 97)//a - rotate left
		{	standby1 = false;
			forward1 = false;
			backward1= false;
			right1   = false;
			left1    = true;
			attack1  = false;
			defence1 = false;
			std::cout<<"6sides robot turning left "<<std::endl;
		}
		else if(char_code == 100)//d - rotate right
		{	standby1 = false;
			forward1 = false;
			backward1= false;
			right1   = true;
			left1    = false;
			attack1  = false;
			defence1 = false;
			std::cout<<"6sides robot turning right "<<std::endl;
		}
		else if(char_code == 117)//u
		{	standby2 = false;
			forward2 = false;
			backward2= false;
			right2   = false;
			left2    = false;
			attack2= false;
			defence2= true;
			shoot = 0x01;
			std::cout<<"5sides robot defends"<<std::endl;
		}
		else if(char_code == 116)//t
		{	standby2 = false;
			forward2 = false;
			backward2= false;
			right2   = false;
			left2    = false;
			attack2= true;
			defence2= false;
			shoot = 0x01;
			std::cout<<"5sides robot attacks "<<std::endl;
		}
		else if(char_code == 121)//y
		{	standby2 = false;
			forward2 = true;
			backward2= false;
			right2   = false;
			left2    = false;
			attack2  = false;
			defence2 = false;
			std::cout<<"5sides robot moving forward "<<std::endl;
		}
		else if(char_code == 104)//h
		{	standby2 = true;
			forward2 = false;
			backward2= false;
			right2   = false;
			left2    = false;
			attack2  = false;
			defence2 = false;
			std::cout<<"5sides robot stops "<<std::endl;
		}
		else if(char_code == 110)//n
		{
			standby2 = false;
			forward2 = false;
			backward2= true;
			right2   = false;
			left2    = false;
			attack2  = false;
			defence2 = false;
			std::cout<<"5sides robot moving backward "<<std::endl;
		}
		else if(char_code == 103)//g
		{	standby2 = false;
			forward2 = false;
			backward2= false;
			right2   = false;
			left2    = true;
			attack2  = false;
			defence2 = false;
			std::cout<<"5sides robot rotating left "<<std::endl;
		}
		else if(char_code == 106)//j
		{	standby2 = false;
			forward2 = false;
			backward2= false;
			right2   = true;
			left2    = false;
			attack2  = false;
			defence2 = false;
			std::cout<<"5sides robot rotating right "<<std::endl;
		}
		else if(char_code == 91)//[
		{	standby3 = false;
			forward3 = false;
			backward3= false;
			right3   = false;
			left3    = false;
			attack3= false;
			defence3= true;
			shoot = 0x01;
			std::cout<<"4sides robot defends "<<std::endl;
		}
		else if(char_code == 111)//o
		{	standby3 = false;
			forward3 = false;
			backward3= false;
			right3   = false;
			left3    = false;
			attack3= true;
			defence3= false;
			shoot = 0x01;
			std::cout<<"4sides robot attacks "<<std::endl;
		}
		else if(char_code == 112)//p
		{	standby3 = false;
			forward3 = true;
			backward3= false;
			right3   = false;
			left3    = false;
			attack3= false;
			defence3= false;
			std::cout<<"4sides robot moving forward "<<std::endl;
		}
		else if(char_code == 47)///
		{	standby3 = false;
			forward3 = false;
			backward3= true;
			right3   = false;
			left3    = false;
			attack3= false;
			defence3= false;
			std::cout<<"4sides robot moving backward "<<std::endl;
		}
		else if(char_code == 59)//;
		{
			standby3 = true;
			forward3 = false;
			backward3= false;
			right3   = false;
			left3    = false;
			attack3= false;
			defence3= false;
			std::cout<<"4sides robot stops "<<std::endl;
		}
		else if(char_code == 108)//l
		{	standby3 = false;
			forward3 = false;
			backward3= false;
			right3   = false;
			left3    = true;
			attack3= false;
			defence3= false;
			std::cout<<"4sides robot rotating left "<<std::endl;
		}
		else if(char_code == 39)//'
		{	standby3 = false;
			forward3 = false;
			backward3= false;
			right3   = true;
			left3    = false;
			attack3= false;
			defence3= false;
			std::cout<<"4sides robot rotating right "<<std::endl;
		}
		else if(char_code == 55)//7 - ALL defence
		{	
			attack1 = false;
			defence1 = true;
			forward1 = false;
			backward1= false;
			right1   = false;
			left1    = false;
			attack2 = false;
			defence2 = true;
			attack3 = false;
			defence3 = true;
			standby1 = false;
			standby2 = false;
			standby3 = false;
			shoot = 0x01;
			std::cout<<"ALL def "<<std::endl;
		}
		else if(char_code == 56)//8 - ALL chase the puck
		{
			attack1 = true;
			defence1 = false;
			attack2 = true;
			defence2 = false;
			attack3 = true;
			defence3 = false;
			standby1 = false;
			standby2 = false;
			standby3 = false;
			std::cout<<"ALL attack "<<std::endl;
		}
		else
			if (char_code!= -1)
				break;
	}


	sensor->NuiShutdown();
    sensor->NuiSkeletonTrackingDisable();
    interactionStream->Disable();
	
	delete interclient;

   /* CloseHandle( colorEvent );*/
    CloseHandle( depthEvent );
    CloseHandle( skeletonEvent );
    CloseHandle( interactionEvent );    
    //CloseHandle( colorHandle );
    CloseHandle( depthHandle );    

	
	cv::destroyAllWindows();
	return 0;
}

unsigned char CheckSum(unsigned char * p, unsigned char len)
{
 unsigned char result = 0x00;
 unsigned char i;
 unsigned char * pointer;
 pointer = p;
 for (i = 0; i < len; i++)
 {
  result ^= *pointer;
  pointer ++;
 }
 return result;
}
