//Mixed reality Mirohot with Kinect by Shiou-Min Shen
//KinectTODO.h contains functions to process Kinect data stream

#include <iostream>
#include <Windows.h>
#include <NuiApi.h>
#include <KinectInteraction.h>
#include <opencv2/opencv.hpp>
//#include <FaceTrackLib.h>
#include <stdlib.h>

//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_core249d.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_highgui249d.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_calib3d249d.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_contrib249d.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_features2d249d.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_flann249d.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_gpu249d.lib")
////#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_haartraining_engined.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_imgproc249d.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_legacy249d.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_ml249d.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_objdetect249d.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_ts249d.lib")
//#pragma comment(lib,"C:\\opencv\\build\\x86\\vc10\\lib\\opencv_video249d.lib")

int roundint( float r );
int roundint( double r );


enum HANDTYPE
{
    LEFT = 0,
    RIGHT,
	HANDSTOTAL,
	selectNONE = 99
};

struct HandInfo
{
	float X,Y;
	double drawX, drawY;
	bool doGrip;
	bool didGrip;
	bool isValid;
	DWORD SkeletonTrackingId;
	int selectbot;
	void init();
};

struct UserInfo
{
	HandInfo hands[HANDSTOTAL];
	void init();
};




//void DrawJoint(INuiSensor* sensor, IplImage *cvImageColor, Vector4 position);
void DrawJoint(cv::Mat &cvImageColor, Vector4 position, INuiSensor* sensor);
//void DrawSkeleton(IplImage *cvImageColor, const NUI_SKELETON_DATA & skel, CvPoint2D32f *m_Points, int windowWidth, int windowHeight);
void DrawSkeleton(cv::Mat &cvImageColor, CvPoint *SkeletonPts, INuiSensor* sensor, const NUI_SKELETON_DATA & skel );
//void DrawBone(IplImage *cvImageColor, const NUI_SKELETON_DATA & skel, CvPoint2D32f *m_Points, NUI_SKELETON_POSITION_INDEX joint0, NUI_SKELETON_POSITION_INDEX joint1);
void DrawBone(cv::Mat &cvImageColor, CvPoint *SkeletonPts, const NUI_SKELETON_DATA & skel, NUI_SKELETON_POSITION_INDEX joint0, NUI_SKELETON_POSITION_INDEX joint1);
//int ProcessColor(HANDLE h, INuiSensor* sensor, IplImage *cvImageColor);
int ProcessColor(cv::Mat &cvImageColor, HANDLE h, INuiSensor* sensor );
//int ProcessSkeleton(INuiSensor* sensor, INuiInteractionStream* interactionStream, IplImage *cvImageColor);
int ProcessSkeleton(cv::Mat &cvImageColor, CvPoint *SkeletonPts, INuiSensor* sensor, INuiInteractionStream* interactionStream);
int ProcessInteraction(INuiInteractionStream* interactionStream, UserInfo *iPlayers);
//int ProcessDepth(HANDLE h, INuiSensor* sensor, IplImage *cvImageDepth, BYTE *depthBuffer, INuiInteractionStream* interactionStream);
int ProcessDepth(cv::Mat &cvImageDepth, BYTE *depthBuffer, HANDLE h, INuiSensor* sensor, INuiInteractionStream* interactionStream );

void Initialize();
void Run();
void Update();

CvPoint2D32f SkeletonToScreen(Vector4 skeletonPoint, int width, int height);

class CIneractionClient : public INuiInteractionClient
{
    public:
	CIneractionClient(){}
	~CIneractionClient(){}

	ULONG STDMETHODCALLTYPE AddRef()
	{
		return 2;
	}

	ULONG STDMETHODCALLTYPE Release()
	{
		return 1;
	}

	HRESULT STDMETHODCALLTYPE QueryInterface( REFIID riid, void **ppv )
	{
		return S_OK;
	}

	HRESULT STDMETHODCALLTYPE GetInteractionInfoAtLocation( DWORD skeletonTrackingId, NUI_HAND_TYPE handType, FLOAT x, FLOAT y, _Out_ NUI_INTERACTION_INFO *pInteractionInfo )
	{
		if( pInteractionInfo ){
			if( handType == NUI_HAND_TYPE_RIGHT ){
				pInteractionInfo->IsGripTarget = true;
				pInteractionInfo->IsPressTarget = true;
				pInteractionInfo->PressTargetControlId = 1;
			}
			else if( handType == NUI_HAND_TYPE_LEFT ){
				pInteractionInfo->IsGripTarget = true;
				pInteractionInfo->IsPressTarget = true;
				pInteractionInfo->PressTargetControlId = 2;
			}    
			else if( handType == NUI_HAND_TYPE_NONE ){
				pInteractionInfo->PressTargetControlId = 0;
			}    

			pInteractionInfo->PressAttractionPointX = 0.f;
			pInteractionInfo->PressAttractionPointY = 0.f;

			return S_OK;
		}
		return E_POINTER;
	}
};